"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.addLintStaged = void 0;
const commitWithAuthor_1 = require("../helpers/commitWithAuthor");
const installPackage_1 = require("../helpers/installPackage");
const withStateLogger_1 = require("../helpers/withStateLogger");
const writeAndAddFile_1 = require("../helpers/writeAndAddFile");
exports.addLintStaged = (0, withStateLogger_1.withStateLogger)({ id: "lint staged", message: "Setting up linting for staged files" }, (config) => __awaiter(void 0, void 0, void 0, function* () {
    yield (0, installPackage_1.installPackage)(config, ["lint-staged", "tsc-files"]);
    const lintStagedRcObject = {
        "*.+(ts|tsx)": ["prettier --write", "eslint --cache --fix", "tsc-files --noEmit"],
        "*.+(js|jsx)": ["prettier --write", "eslint --cache --fix"],
        "*.+(json|css|md|yml|yaml|scss)": ["prettier --write"],
    };
    yield (0, writeAndAddFile_1.writeAndAddFile)(config, ".lintstagedrc.json", JSON.stringify(lintStagedRcObject, null, 2));
    yield (0, commitWithAuthor_1.commitWithAuthor)(config, "Install lint-staged");
}));
